1 => int on;



// init OSC /////////////////////////////////////////
OscSend send; //send OSC
send.setHost( "localhost", 9000);
OscRecv recv; //recv OSC
9001 => recv.port;
recv.listen(); // start listening (launch thread)


// OSC classes and functions ////
fun void oscShred( OscEvent e, OscAction a ){
	e @=> a.e; //pass event
	while (true){
		e => now;
		if (e.nextMsg()){a.action();}
	}
}

fun void oscShred( OscEvent e, OscAction a, int n ){
	e @=> a.e; //pass event
	n => a.n; //pass index number
	while (true){
		e => now;
		if (e.nextMsg()){a.action();}
	}
}

class OscAction{
    OscEvent e; int n;
    fun void action(){}
}

/////////////////////////////////////////

class StatusAction extends OscAction{
    fun void action(){
        if (e.getInt()){
            <<<"connected msg received from widgets server">>>;
            send.startMsg( "/connected", "f" );
            1 => send.addFloat; // send connected message to graphics
        } else {
            <<<"widgets server just quit">>>;
        }
    }
}
class QuitAction extends OscAction{
    fun void action(){ 0 => on; }
}
///////// widgets
class Toggle1Action extends OscAction{
    fun void action(){ <<<"toogle1", e.getInt()>>>; }
}
class Button1Action extends OscAction{
    fun void action(){ <<<"button1", e.getInt()>>>; }
}
class Slider1Action extends OscAction{
    fun void action(){ <<<"slider1", e.getInt()>>>; }
}
class Slider2Action extends OscAction{
    fun void action(){ <<<"slider2", e.getInt()>>>; }
}
class Choice1Action extends OscAction{
    fun void action(){ <<<"choice1", e.getString()>>>; }
}
class Radio1Action extends OscAction{
    fun void action(){ <<<"radio1", e.getString()>>>; }
}
class Num1Action extends OscAction{
    fun void action(){ <<<"num1", e.getInt()>>>; }
}


// bind addressed to events
recv.event("/connected, i") @=> OscEvent connected_osc;
recv.event("/quit, i") @=> OscEvent quit_osc;
/// widgets
recv.event("/toggle1, i") @=> OscEvent toggle1_osc;
recv.event("/button1, i") @=> OscEvent button1_osc;
recv.event("/slider1, i") @=> OscEvent slider1_osc;
recv.event("/slider2, i") @=> OscEvent slider2_osc;
recv.event("/choice1, s") @=> OscEvent choice1_osc;
recv.event("/radio1, s") @=> OscEvent radio1_osc;
recv.event("/num1, i") @=> OscEvent num1_osc;


// OSC shreds
spork ~ oscShred(connected_osc, new StatusAction);
spork ~ oscShred(quit_osc, new QuitAction);
/// widgets
spork ~ oscShred(toggle1_osc, new Toggle1Action);
spork ~ oscShred(button1_osc, new Button1Action);
spork ~ oscShred(slider1_osc, new Slider1Action);
spork ~ oscShred(slider2_osc, new Slider2Action);
spork ~ oscShred(choice1_osc, new Choice1Action);
spork ~ oscShred(radio1_osc, new Radio1Action);
spork ~ oscShred(num1_osc, new Num1Action);



<<<"chuck osc receiver up and runing ...">>>;

//entering main loop //
while (on){ // quits when on is false
	0.2::second => now; 
}

<<<"quiting ChucK">>>; //print quit

